'''
Command Module that handles top level parsing of the rita command
and dispatches the args to the required post-processor
'''
import argparse
import sys
import os
import importlib
import rita
import rita.pprocs
import rita.version
import pkgutil


def print_available_stats():
    '''Function to list the available stats options'''
    for item in pkgutil.walk_packages(rita.pprocs.__path__):
        lib = importlib.import_module('rita.pprocs.' + item[1])
        print(lib.help_message)

def setup_cmdline_args():
    '''Function to setup the command line arguments parser'''
    parser = argparse.ArgumentParser(
        prog="rita",
        description="Tool to process a RISC-V trace file. \
        Currently suports the log file generated by spike",
    )

    parser.add_argument(
        '--trace-file',
        type=str,
        metavar='FILE',
        help="Stack trace file to be analyzed"
    )

    parser.add_argument(
        '--temp-file',
        type=str,
        metavar='FILE',
        help="input template file"
    )

    parser.add_argument(
        '--out-file',
        type=str,
        metavar='FILE',
        help="Modified Spike File (Intermediate) - For Debug"
    )

    parser.add_argument(
        '--disass-file',
        type=str,
        metavar='FILE',
        help="Disass file to find sequence"
    )

    parser.add_argument(
        '--modif-disass-path',
        type=str,
        metavar='FILE',
        help="Path to create modified Disass file"
    )

    parser.add_argument(
        '--addr-min',
        help="Minimum address to start analyzing",
        type=lambda x: int(x, 0)
    )

    parser.add_argument(
        '--addr-max',
        help="Maximum address to start analyzing (inclusive)",
        type=lambda x: int(x, 0)
    )

    parser.add_argument(
        '--output-size',
        help="Maximum number of items to return for frequency \
                based stats. Ordered by highest frequency",
        metavar = 'OSIZE',
        type = int
    )

    parser.add_argument(
        '--seq-size',
        help="Size of sequence to find",
        metavar='SSIZE',
        type=int
    )

    parser.add_argument(
        '--version',
        action='version',
        version=rita.version.version.strip()
    )

    parser.add_argument(
        '--list-stats',
        action='store_true',
        help='List the stats available'
    )

    parser.add_argument(
        '--stat',
        type=str,
        help='Statistic to output. Check --list-stats for available options'
    )

    parser.add_argument(
        '--mode',
        type=str,
        nargs = '?',
        const = 'standard',
        help='Select mode of trace file input. [standard|custom], default = standard'
    )

    return parser

def execute():
    parser = setup_cmdline_args()

    # Print the help message to stderr if no arg specified
    if len(sys.argv) == 1:
        parser.print_help(sys.stderr)
        return 0

    args = parser.parse_args()

    # List the stats if option selected
    if args.list_stats:
        print("")
        print("Available statistics options")
        print("================================\n")
        print("{:<20s} {:<10s}".format("Option", "Description"))
        print("--------------------------------")
        print_available_stats()
        return 0

    # Pass the args to the selected subcommand
    if args.stat is not None:

        # Return if trace file not provided
        if args.trace_file is None:
            print("\nTrace file not selected")
            print("Provide trace file using the --trace-file option\n")
            return 0


        stat_list = [x[1] for x in pkgutil.walk_packages(rita.pprocs.__path__)]
        if args.stat not in stat_list:
            print("\nStatistic selected not available\n")
            print("Statistics available")
            print("====================")
            print_available_stats()
            print('')
            return 0

        print("\nStatistic selected: {0}".format(args.stat))
        print("===========================================")

        # Create the path to the trace file
        trace_file_abspath = ''
        if os.path.isabs(args.trace_file):
            trace_file_abspath = os.path.abspath(args.trace_file)
        else:
            trace_file_abspath = os.path.abspath(
                os.path.join(os.getcwd(), args.trace_file))

        #print(args.stat)
        if(args.stat == 'seq_extr'):
            temp_file_abspath = ''
            if os.path.isabs(args.temp_file):
                temp_file_abspath = os.path.abspath(args.temp_file)
            else:
                temp_file_abspath = os.path.abspath(
                os.path.join(os.getcwd(), args.temp_file))
            
            disass_file_abspath = ''
            if os.path.isabs(args.disass_file):
                disass_file_abspath = os.path.abspath(args.disass_file)
            else:
                disass_file_abspath = os.path.abspath(
                os.path.join(os.getcwd(), args.disass_file))

            modif_disass_file_abspath = ''
            if os.path.isabs(args.modif_disass_path):
                modif_disass_file_abspath = os.path.abspath(args.modif_disass_path)
            else:
                modif_disass_file_abspath = os.path.abspath(
                os.path.join(os.getcwd(), args.modif_disass_path))

            if args.out_file is None:
                out_file_abspath = 'out_optimized'
            else:
                out_file_abspath = ''
                if os.path.isabs(args.out_file):
                    out_file_abspath = os.path.abspath(args.out_file)
                else:
                    out_file_abspath = os.path.abspath(
                    os.path.join(os.getcwd(), args.out_file))

            stat_module = importlib.import_module('rita.pprocs.' + args.stat)
            stat_module.compute(trace_file_abspath, temp_file_abspath, disass_file_abspath, modif_disass_file_abspath, out_file_abspath,args)

        else:
            stat_module = importlib.import_module('rita.pprocs.' + args.stat)
            stat_module.compute(trace_file_abspath, args)
        
        
        return 0

    return 0

def execute_notebook(args):
    '''Function to execute rita in the notebook'''
    if args.stat is not None:

        # Return if trace file not provided
        if args.trace_file is None:
            print("\nTrace file not selected")
            print("Provide trace file using the --trace-file option\n")
            return 0

        stat_list = [x[1] for x in pkgutil.walk_packages(rita.pprocs.__path__)]
        if args.stat not in stat_list:
            print("\nStatistic selected not available\n")
            print("Statistics available")
            print("====================")
            print_available_stats()
            print('')
            return 0

        print("\nStatistic selected: {0}".format(args.stat))
        print("===========================================")

        # Create the path to the trace file
        trace_file_abspath = ''
        if os.path.isabs(args.trace_file):
            trace_file_abspath = os.path.abspath(args.trace_file)
        else:
            trace_file_abspath = os.path.abspath(
                os.path.join(os.getcwd(), args.trace_file))

        # Execute the stat command
        stat_module = importlib.import_module('rita.pprocs.' + args.stat)
        stat_module.compute(trace_file_abspath, args)
        return 'Completed'

if __name__ == '__main__':
    execute()
